#include <iostream>
#include <string>
#include <memory>

class DataStructure {
public:
	
	typedef std::shared_ptr<DataStructure> Ref;
	
private:
	
	float mValue;
	
public:
	
	DataStructure() : mValue( 0.0 )
	{
		std::cout << "DataStructure::DataStructure()" << std::endl;
	}
	
	~DataStructure()
	{
		std::cout << "DataStructure::~DataStructure()" << std::endl;
	}
	
	void setValue(float iValue)
	{
		std::cout << "DataStructure::setValue( " << iValue << " ) -> void" << std::endl;
		mValue = iValue;
	}
	
	const float& getValue() const
	{
		std::cout << "DataStructure::getValue() -> const float&" << std::endl;
		return mValue;
	}
};

class FileLoader {
public:

	FileLoader()
	{
		std::cout << "FileLoader::FileLoader()" << std::endl;
	}
	
	~FileLoader()
	{
		std::cout << "FileLoader::~FileLoader()" << std::endl;
	}
	
	DataStructure::Ref loadFile(const std::string& iPath)
	{
		std::cout << "FileLoader::loadFile( " << iPath << " ) -> DataStructure::Ref" << std::endl;
		return std::make_shared<DataStructure>();
	}
};

class Controller {
private:
	
	DataStructure::Ref mData;
	
public:
	
	Controller(const std::string& iPath)
	{
		std::cout << "Controller::Controller()" << std::endl;
		FileLoader tLoader = FileLoader();
		mData = tLoader.loadFile( iPath );
	}
	
	~Controller()
	{
		std::cout << "Controller::~Controller()" << std::endl;
	}
	
	DataStructure::Ref getData()
	{
		std::cout << "Controller::getData() -> DataStructure::Ref" << std::endl;
		return mData;
	}
};

int main(int argc, const char * argv[])
{
	Controller tController = Controller( "/some/directory/file.txt" );

    return 0;
}
